3 # Copyright (c) 2005 Junio C Hamano
6 # Keep the original TERM for say_color
9 # For repeatability, reset the environment to known value.
15 export LANG LC_ALL PAGER TERM TZ
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
27 GIT_AUTHOR_EMAIL=author@example.com
28 GIT_AUTHOR_NAME='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL=committer@example.com
31 GIT_COMMITTER_NAME='C O Mitter'
35 unset GIT_EXTERNAL_DIFF
37 unset GIT_OBJECT_DIRECTORY
38 unset SHA1_FILE_DIRECTORIES
39 unset SHA1_FILE_DIRECTORY
41 export GIT_MERGE_VERBOSITY
42 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
43 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
45 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
47 # Protect ourselves from common misconfiguration to export
48 # CDPATH into the environment
51 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
53 echo "* warning: Some tests will not work if GIT_TRACE" \
54 "is set as to trace on STDERR ! *"
55 echo "* warning: Please set GIT_TRACE to something" \
56 "other than 1, 2 or true ! *"
60 # Each test should start with something like this, after copyright notices:
62 # test_description='Description of this test...
63 # This test checks if command xyzzy does the right thing...
66 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
67 TERM=$ORIGINAL_TERM &&
70 tput bold >/dev/null 2>&1 &&
71 tput setaf 1 >/dev/null 2>&1 &&
72 tput sgr0 >/dev/null 2>&1
79 -d|--d|--de|--deb|--debu|--debug)
81 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83 -h|--h|--he|--hel|--help)
85 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
87 -q|--q|--qu|--qui|--quie|--quiet)
99 if test -n "$color"; then
105 error) tput bold; tput setaf 1;; # bold red
106 skip) tput bold; tput setaf 2;; # bold green
107 pass) tput setaf 2;; # green
108 info) tput setaf 3;; # brown
109 *) test -n "$quiet" && return;;
118 test -z "$1" && test -n "$quiet" && return
125 say_color error "error: $*"
134 test "${test_description}" != "" ||
135 error "Test script did not set test_description."
137 if test "$help" = "t"
139 echo "$test_description"
144 if test "$verbose" = "t"
148 exec 4>/dev/null 3>/dev/null
157 echo >&5 "FATAL: Unexpected exit with code $?"
164 if test -z "${test_tick+set}"
168 test_tick=$(($test_tick + 60))
170 GIT_COMMITTER_DATE="$test_tick -0700"
171 GIT_AUTHOR_DATE="$test_tick -0700"
172 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
175 # You are not expected to call test_ok_ and test_failure_ directly, use
176 # the text_expect_* functions instead.
179 test_count=$(expr "$test_count" + 1)
180 say_color "" " ok $test_count: $@"
184 test_count=$(expr "$test_count" + 1)
185 test_failure=$(expr "$test_failure" + 1);
186 say_color error "FAIL $test_count: $1"
188 echo "$@" | sed -e 's/^/ /'
189 test "$immediate" = "" || { trap - exit; exit 1; }
192 test_known_broken_ok_ () {
193 test_count=$(expr "$test_count" + 1)
194 test_fixed=$(($test_fixed+1))
195 say_color "" " FIXED $test_count: $@"
198 test_known_broken_failure_ () {
199 test_count=$(expr "$test_count" + 1)
200 test_broken=$(($test_broken+1))
201 say_color skip " still broken $test_count: $@"
205 test "$debug" = "" || eval "$1"
215 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
216 this_test="$this_test.$(expr "$test_count" + 1)"
218 for skp in $GIT_SKIP_TESTS
227 say_color skip >&3 "skipping test: $@"
228 test_count=$(expr "$test_count" + 1)
229 say_color skip "skip $test_count: $1"
238 test_expect_failure () {
240 error "bug in the test script: not 2 parameters to test-expect-failure"
243 say >&3 "checking known breakage: $2"
245 if [ "$?" = 0 -a "$eval_ret" = 0 ]
247 test_known_broken_ok_ "$1"
249 test_known_broken_failure_ "$1"
255 test_expect_success () {
257 error "bug in the test script: not 2 parameters to test-expect-success"
260 say >&3 "expecting success: $2"
262 if [ "$?" = 0 -a "$eval_ret" = 0 ]
272 test_expect_code () {
274 error "bug in the test script: not 3 parameters to test-expect-code"
277 say >&3 "expecting exit code $1: $3"
279 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
289 # This is not among top-level (test_expect_success | test_expect_failure)
290 # but is a prefix that can be used in the test script, like:
292 # test_expect_success 'complain and die' '
294 # do something else &&
295 # test_must_fail git checkout ../outerspace
298 # Writing this as "! git checkout ../outerspace" is wrong, because
299 # the failure could be due to a segv. We want a controlled failure.
303 test $? -gt 0 -a $? -le 129
306 # test_cmp is a helper function to compare actual and expected output.
307 # You can use it like:
309 # test_expect_success 'foo works' '
310 # echo expected >expected &&
312 # test_cmp expected actual
315 # This could be written as either "cmp" or "diff -u", but:
316 # - cmp's output is not nearly as easy to read as diff -u
317 # - not all diff versions understand "-u"
323 # Most tests can use the created repository, but some may need to create more.
324 # Usage: test_create_repo <directory>
325 test_create_repo () {
327 error "bug in the test script: not 1 parameter to test-create-repo"
331 cd "$repo" || error "Cannot setup test environment"
332 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
333 error "cannot run git init -- have you built things yet?"
334 mv .git/hooks .git/hooks-disabled
341 if test "$test_fixed" != 0
343 say_color pass "fixed $test_fixed known breakage(s)"
345 if test "$test_broken" != 0
347 say_color error "still have $test_broken known breakage(s)"
348 msg="remaining $(($test_count-$test_broken)) test(s)"
350 msg="$test_count test(s)"
352 case "$test_failure" in
355 # cd .. && rm -fr trash
356 # but that means we forbid any tests that use their own
357 # subdirectory from calling test_done without coming back
358 # to where they started from.
359 # The Makefile provided will clean this test area so
360 # we will leave things as they are.
362 say_color pass "passed all $msg"
366 say_color error "failed $test_failure among $msg"
372 # Test the binaries we have just built. The tests are kept in
373 # t/ subdirectory and are run in trash subdirectory.
375 GIT_EXEC_PATH=$(pwd)/..
376 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
378 unset GIT_CONFIG_LOCAL
379 GIT_CONFIG_NOSYSTEM=1
380 GIT_CONFIG_NOGLOBAL=1
381 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
383 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
385 test -d ../templates/blt || {
386 error "You haven't built things yet, have you?"
389 if ! test -x ../test-chmtime; then
390 echo >&2 'You need to build test-chmtime:'
391 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
395 . ../GIT-BUILD-OPTIONS
401 echo >&5 "FATAL: Cannot prepare test area"
405 test_create_repo $test
408 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
409 for skp in $GIT_SKIP_TESTS
412 for skp in $GIT_SKIP_TESTS
421 say_color skip >&3 "skipping test $this_test altogether"
422 say_color skip "skip all tests in $this_test"